%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 100000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 100; % number of monte carlo trials

%p0 = 0.3; % assumed sparsity
 
mu = 1; % actual sparsity, and post-change mean
%% generate stardard signal
signal_forARL = randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end


%% Build statistic for estimating DD
%N=20
%b = 12:0.5:20;

%N=100
b=34:1:35;

ARL = zeros(length(b),1);

for l = 1 : length(b)
    tmp = zeros(mc,1);
    for runs = 1 : mc
        signal_forARL = randn(N,T)*sigma0;
        signal = signal_forARL;
        C = zeros(N,1); L = zeros(N,1); M = zeros(w,1); ans1 = zeros(T,1);
        alpha = ones(N,1); beta = 10*ones(N,1); p0 = betarnd(alpha,beta);
        for t = 1 : T
            % Accelaration part (for i = ... end)
            temp = zeros(N,w);
            temp(:,1) = signal(:,t); temp1 = signal(:,t);
            for i = (t-2) : -1 : max(t-w,0)
                temp1 = temp1 + signal(:,i+1);
                temp(:,t-i) = temp(:,t-i-1) + temp1;
            end
            Indi = zeros(N,1);
            %tt = zeros(N,1);
            for k = (t-1) : -1 : max(t-w,0)
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    L(n,1) = temp(n,t-k)^2/square(t-k)/2;
                    if (sqrt(L(n,1)) > 2 )
                        Indi(n) = 1;
                    end
                    %L(n,1) = randn(1,1)^2/2;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                M(t-k,1) = sum(log(1-p0+p0.*exp(L)));
            end
            ans1(t) = max(M);
            if (ans1(t) > b(l) )
                break;
            end
            %update parameter
            for n = 1 : N
                if (Indi(n)==0)
                    if (alpha(n)>beta(n))
                        alpha(n)=1;beta(n)=1;
                    else
                        beta(n)=beta(n)+1;
                    end
                else
                    if (alpha(n)<beta(n))
                        alpha(n)=1;beta(n)=1;
                    else
                        alpha(n)=alpha(n)+1;
                    end                    
                end
            end
            %random sample p by posterior distribution
            p0 = betarnd(alpha,beta);
        end
        tmp(runs,1) = t;
    end
    ARL(l) = sum(tmp)/mc;
end


ARL_theo = zeros(length(b),1);
for i = 1 : length(b)
    ARL_theo(i) = theo_ARL_two(b(i),N,p0,w);
end
plot(b,ARL);hold on; plot(b,ARL_theo,'r-');
