%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 100000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 100; % number of monte carlo trials

%p0 = 0.3; % assumed sparsity
 
mu = 1; % actual sparsity, and post-change mean
%% generate stardard signal
signal_forARL = randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end


%% Build statistic for estimating DD
%N=20
%b = 12:0.5:20;

%N=100
b=15:1:15;

ARL = zeros(length(b),1);

for l = 1 : length(b)
    tmp = zeros(mc,1);
    alpha = ones(N,1); beta = 10*ones(N,1); 
    for runs = 1 : mc
        signal_forARL = randn(N,T)*sigma0;
        signal = signal_forARL;
        C = zeros(N,1); L = zeros(N,1); V = zeros(N,w); M = zeros(w,1); ans1 = zeros(T,1);
        p0 = betarnd(alpha,beta);
        Consec = zeros(N,1);
        for t = 1 : T
            Indi = zeros(N,1); 
            %tt = zeros(N,1);
            for k = min(w,t) : -1 : 2  
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    V(n,k) = V(n,k-1) + k*signal(n,t);
                    L(n,1) = V(n,k)^2/square(k)/2;
                    if (sqrt(L(n,1)) > 2 )
                        Indi(n) = 1;
                    end
                    %L(n,1) = randn(1,1)^2/2;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                M(k,1) = sum(log(1-p0+p0.*exp(L)));
            end
            V(:,1) = signal(:,t);
            M(1,1) = sum(log(1-p0+p0.*exp(V(:,1).^2./2)));
            ans1(t) = max(M);
            if (ans1(t) > b(l) )
                break;
            end
            %update parameter
            %{
            for n = 1 : N
                if (Indi(n)==0)
                    if (Consec(n)>0)
                        alpha(n)=1;beta(n)=10;
                    else
                        beta(n)=beta(n)+1;
                    end
                    Consec(n)=0;
                else
                    alpha(n) = alpha(n) + 2^Consec(n);
                    Consec(n) = Consec(n) + 1;
                end
            end
            %}
            alpha = alpha + Indi; beta = beta + 1 - Indi;
            %random sample p by posterior distribution
            p0 = betarnd(alpha,beta);
        end
        tmp(runs,1) = t;
    end
    ARL(l) = sum(tmp)/mc;
end


ARL_theo = zeros(length(b),1);
for i = 1 : length(b)
    ARL_theo(i) = theo_ARL_two(b(i),N,p0,w);
end
plot(b,ARL);hold on; plot(b,ARL_theo,'r-');
