%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 40000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 200; % number of monte carlo trials

p0 = .3; % assumed sparsity
 
p = 0.5; mu = 1; % actual sparsity, and post-change mean
Nc = round(p*N); % number of affected sensors

%% generate stardard signal
%signal_stardard = [repmat(zeros(N,1),1,round(T/5*4)),...
%    mu_n*(1:round(T/5))] + randn(N,T)*sigma0; % general signal
%%genearte signal for estimate DD
%signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end



%% Build statistic for estimating DD
slope = 0.01:0.01:1; 

%% DD of slope change 
%{
DD_slope = zeros(length(slope),1); Loc_slope = zeros(length(slope),1);
b=46.35;


%halfway
H = 0;

for l = 1 : length(slope)
    tmp = zeros(mc,1); loc_slope = zeros(mc,1);
    for runs = 1 : mc
        mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope(l)*ones(Nc,1); % generate post-slope vector
        signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;
        signal_forDD = [randn(N,H)*sigma0 signal_forDD];
        signal = signal_forDD;
        C = zeros(N,1); L = zeros(N,1); V = zeros(N,w); M = zeros(w,1); ans1 = zeros(T,1); ans2 = zeros(T,1);
        for t = 1 : T
            for k = min(w,t) : -1 : 2  
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    V(n,k) = V(n,k-1) + k*signal(n,t);
                    L(n,1) = V(n,k)^2/square(k)/2;
                    %L(n,1) = randn(1,1)^2/2;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                 M(k,1) = sum(log(1-p0+p0.*exp(L)));
            end
            V(:,1) = signal(:,t);
            M(1,1) = sum(log(1-p0+p0.*exp(V(:,1).^2./2)));
            [ans1(t) ans2(t)] = max(M);
            if ((ans1(t) > b ) && (t>H))
                break;
            end
        end
        tmp(runs,1) = t-H; loc_slope(runs,1) = t-H-ans2(t);
    end
    DD_slope(l) = sum(tmp)/mc; Loc_slope(l) = sum(loc_slope.^2)/mc;
end
%}

%% DD of mean shift

DD_mean = zeros(length(slope),1); Loc_mean = zeros(length(slope),1);
b=47.45;

%halfway
H = 0;

for l = 1 : length(slope)
    tmp = zeros(mc,1); loc_mean = zeros(mc,1);
    for runs = 1 : mc
        mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope(l)*ones(Nc,1); % generate post-slope vector
        signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;
        signal_forDD = [randn(N,H)*sigma0 signal_forDD];
        signal = signal_forDD;
        C = zeros(N,1); L = zeros(N,1); M = zeros(w,1); ans1 = zeros(T,1); ans2 = zeros(T,1);
        for t = 1 : T
            % Accelaration part (for i = ... end)
            %temp = zeros(N,w);
            %temp(:,1) = signal(:,t); temp1 = signal(:,t);
            %for i = (t-2) : -1 : max(t-w,0)
            %    temp1 = temp1 + signal(:,i+1);
            %    temp(:,t-i) = temp(:,t-i-1) + temp1;
            %end
            tt = zeros(N,1);
            for k = (t-1) : -1 : max(t-w,0)
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    %L(n,1) = temp(n,t-k)^2/square(t-k)/2;
                    %L(n,1) = randn(1,1)^2/2;
                    tt(n) = tt(n) + signal(n,k+1);
                    L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                M(t-k,1) = sum(log(1-p0+p0*exp(L)));
            end
            [ans1(t) ans2(t)] = max(M);
            if ((ans1(t) > b ) && (t>H))
                break;
            end
        end
        tmp(runs,1) = t-H; loc_mean(runs,1) = t-H-ans2(t);
    end
    DD_mean(l) = sum(tmp)/mc; Loc_mean(l) = sum(loc_mean.^2)/mc;
end


%% Multichart
%{
T=1000;
DD_chart = zeros(length(slope),1); Loc_chart = zeros(length(slope),1);
b=6.34;
delta=1; delta_n = ones(N,1)*delta;

%halfway
H = 0;

for l = 1 : length(slope)
    tmp = zeros(mc,1); loc_chart = zeros(mc,1);
    for runs = 1 : mc
        %W(:,1) = zeros(N,1); M=zeros(N,1);
        mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope(l)*ones(Nc,1); % generate post-slope vector
        signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;
        signal_forDD = [randn(N,H)*sigma0 signal_forDD];
        signal = signal_forDD;
        M = zeros(w,1); ans1 = zeros(T,1); ans2 = zeros(T,1);
        for t = 1 : T
            % Accelaration part (for i = ... end)
            %temp = zeros(N,w);
            %temp(:,1) = signal(:,t); temp1 = signal(:,t);
            %for i = (t-2) : -1 : max(t-w,0)
            %    temp1 = temp1 + signal(:,i+1);
            %    temp(:,t-i) = temp(:,t-i-1) + temp1;
            %end
            tt = zeros(N,1);
            for k = (t-1) : -1 : max(t-w,0)
                %for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    %L(n,1) = temp(n,t-k)^2/square(t-k)/2;
                    %L(n,1) = randn(1,1)^2/2;
                    tt = tt+signal(:,k+1).*delta_n - delta_n.^2/2;
                    %L=tt;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                %end
                M(t-k,1) = max(tt);
            end
            [ans1(t) ans2(t)] = max(M);
            if ((ans1(t) > b ) && (t>H))
                break;
            end
        end   
        tmp(runs,1) = t-H; loc_chart(runs,1) = t-H-ans2(t);
    end
    DD_chart(l) = sum(tmp)/mc; Loc_chart(l) = sum(loc_chart.^2)/mc;
end
%}