%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 40000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 500; % number of monte carlo trials

p0 = .1; % assumed sparsity
 
p = 0.1; mu = 1; % actual sparsity, and post-change mean
Nc = round(p*N); % number of affected sensors

%% generate stardard signal
%signal_stardard = [repmat(zeros(N,1),1,round(T/5*4)),...
%    mu_n*(1:round(T/5))] + randn(N,T)*sigma0; % general signal
%%genearte signal for estimate DD
%signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end


%% Build statistic for estimating DD
%slope = 0.01:0.01:1; %Theory Threshold for ARL=5000 based on the paper Yao with David
%DD = zeros(length(slope),1);
b=26.94;

    tmp = zeros(mc,1);
    % initialize alpha and beta
    for runs = 1 : mc
        
        % generating signal
        % mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope(l)*ones(Nc,1); % generate post-slope vector
        rand_c1 = randn*2+5; rand_c2 = randn*2+5;
        rand_c1 = max(1,rand_c1); rand_c1 = min(10,rand_c1); 
        rand_c2 = max(1,rand_c2); rand_c2 = min(10,rand_c2);
        indx = [1:10]; indy = [1:10]; [xx,yy] = meshgrid(indx, indy);
        template = 0.1*exp(-(xx-rand_c1).^2 - (yy-rand_c2).^2); %figure; imagesc(template)
        slope = template(:); % slope
        
        
        signal_forDD = [slope*(1:T)] + randn(N,T)*sigma0;
        %signal_forDD = [randn(N,T)*sigma0 signal_forDD];
        
        signal = signal_forDD;
        C = zeros(N,1); L = zeros(N,1); V = zeros(N,w); M = zeros(w,1); ans1 = zeros(T,1);
        for t = 1 : T
            for k = min(w,t) : -1 : 2  
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    V(n,k) = V(n,k-1) + k*signal(n,t);
                    L(n,1) = V(n,k)^2/square(k)/2;
                    %L(n,1) = randn(1,1)^2/2;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                 M(k,1) = sum(log(1-p0+p0*exp(L)));
            end
            V(:,1) = signal(:,t);
            M(1,1) = sum(log(1-p0+p0*exp(V(:,1).^2./2)));
            ans1(t) = max(M);
            if (ans1(t) > b )
                break;
            end
        end
        tmp(runs,1) = t;
        if (t>50)
            exit;
        end
        % alpha and beta update using the result
    end
    DD = sum(tmp)/mc;



plot(tmp);
