%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 10000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 500; % number of monte carlo trials


 
mu = 1; %post-change mean

%% generate stardard signal
%signal_stardard = [repmat(zeros(N,1),1,round(T/5*4)),...
%    mu_n*(1:round(T/5))] + randn(N,T)*sigma0; % general signal
%%genearte signal for estimate DD
%signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end


%% Build statistic for estimating DD
slope = 0.1; %Theory Threshold for ARL=5000 based on the paper Yao with David
%b1=[26.92, 46.35, 59.72];

%p0 = [0.1, 0.3, 0.5]; % assumed sparsity
p = 0.1:0.1:1.0; % actual sparsity, and post-change mean
b1 = zeros(length(p),1);

%Find threshold to let ARL be 5000 for some p0
for i = 1 : length(p)
    left=10; right=150;
    mid = (left+right)/2; 
    ttt = theo_ARL_two(mid,N,p(i),w);
    while (abs(ttt-5000) > 1e-04)
        if (ttt>5000)
            right = mid;
        else
            left = mid;
        end
        mid = (left+right)/2; 
        ttt = theo_ARL_two(mid,N,p(i),w);
    end
    b1(i) = mid; 
end

DD = zeros(length(p),1);

    for l = 1 : length(p)
        tmp = zeros(mc,1);
        for runs = 1 : mc
            Nc = round(p(l)*N); % number of affected sensors
            mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope*ones(Nc,1); % generate post-slope vector
            signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;
            signal = signal_forDD;
            C = zeros(N,1); L = zeros(N,1); M = zeros(w,1); ans1 = zeros(T,1);
            for t = 1 : T
                % Accelaration part (for i = ... end)
                temp = zeros(N,w);
                temp(:,1) = signal(:,t); temp1 = signal(:,t);
                for i = (t-2) : -1 : max(t-w,0)
                    temp1 = temp1 + signal(:,i+1);
                    temp(:,t-i) = temp(:,t-i-1) + temp1;
                end
                %tt = zeros(N,1);
                for k = (t-1) : -1 : max(t-w,0)
                    for n = 1 : N
                        %C(n,1) = temp(n,t-k) / square(t-k);
                        L(n,1) = temp(n,t-k)^2/square(t-k)/2;
                        %L(n,1) = randn(1,1)^2/2;
                        %tt(n) = tt(n) + signal(n,k+1);
                        %L(n,1) = tt(n)^2/(t-k)/2;
                        %j = 1 : 1 : t-k;
                        %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                        %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                    end
                    M(t-k,1) = sum(log(1-p(l)+p(l)*exp(L)));
                end
                ans1(t) = max(M);
                if (ans1(t) > b1(l) )
                    break;
                end
            end
            tmp(runs,1) = t;
        end
        DD(l) = sum(tmp)/mc;
    end
plot(p,DD);
