%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 40000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 500; % number of monte carlo trials

%p0 = .3; % assumed sparsity
 
p = 0.3; mu = 1; % actual sparsity, and post-change mean
Nc = round(p*N); % number of affected sensors

%% generate stardard signal
%signal_stardard = [repmat(zeros(N,1),1,round(T/5*4)),...
%    mu_n*(1:round(T/5))] + randn(N,T)*sigma0; % general signal
%%genearte signal for estimate DD
%signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end


%% Build statistic for estimating DD
slope = 0.01:0.01:1; %Theory Threshold for ARL=5000 based on the paper Yao with David
DD = zeros(length(slope),1);
b=32.1;



for l = 1 : length(slope)
    tmp = zeros(mc,1);
    for runs = 1 : mc
        mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope(l)*ones(Nc,1); % generate post-slope vector
        signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;
        signal = signal_forDD;
        C = zeros(N,1); L = zeros(N,1); M = zeros(w,1); ans1 = zeros(T,1); 
        alpha = ones(N,1); beta = ones(N,1);  p0 = 0.1*ones(N,1);
        for t = 2 : T
            % Accelaration part (for i = ... end)
            temp = zeros(N,w);
            temp(:,1) = signal(:,t); temp1 = signal(:,t);
            for i = (t-2) : -1 : max(t-w,0)
                temp1 = temp1 + signal(:,i+1);
                temp(:,t-i) = temp(:,t-i-1) + temp1;
            end
            Indi = zeros(N,1);
            for k = (t-1) : -1 : max(t-w,0)
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    L(n,1) = temp(n,t-k)^2/square(t-k)/2;
                    if (sqrt(L(n,1)) > 2 )
                        Indi(n) = 1;
                    end
                    %L(n,1) = randn(1,1)^2/2;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                M(t-k,1) = sum(log(1-p0+p0.*exp(L)));
            end
            ans1(t) = max(M);
            if (ans1(t) > b )
                break;
            end
            %update parameter
            for n = 1 : N
                if (Indi(n)==0)
                    if (alpha(n)>beta(n))
                        alpha(n)=1;beta(n)=1;
                    else
                        beta(n)=beta(n)+1;
                    end
                else
                    if (alpha(n)<beta(n))
                        alpha(n)=1;beta(n)=1;
                    else
                        alpha(n)=alpha(n)+1;
                    end                    
                end
            end
            %alpha = alpha + Indi; beta = beta + 1 - Indi;
            
            %random sample p by posterior distribution
            p0 = betarnd(alpha,beta);
        end
        tmp(runs,1) = t;
    end
    DD(l) = sum(tmp)/mc;
end


plot(slope,theo_DD,'r-');