%%%%
% Find threshold b by simulation. 
%%%%

clear all
close all

N = 100; % number of sensors
T = 40000; % sequence length
w = 200; % window length
sigma0 = 1; % noise variance
mc = 500; % number of monte carlo trials

%p0 = .3; % assumed sparsity
 
p = 0.1; mu = 1; % actual sparsity, and post-change mean
Nc = round(p*N); % number of affected sensors

%% generate stardard signal
%signal_stardard = [repmat(zeros(N,1),1,round(T/5*4)),...
%    mu_n*(1:round(T/5))] + randn(N,T)*sigma0; % general signal
%%genearte signal for estimate DD
%signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;


%% Initialization to save time
square=zeros(w,1);
square(1) = 1;
for i = 1 : w-1
    square(i+1) = square(i) + (i+1)^2;
end


%% Build statistic for estimating DD
slope = 0.01:0.01:1; %Theory Threshold for ARL=5000 based on the paper Yao with David
DD = zeros(length(slope),1);
%b=15.3;
b=14.86;

%halfway
H = 0;

for l = 1 : length(slope)
    tmp = zeros(mc,1);
    for runs = 1 : mc
        mu_n = zeros(N,1); ind = sort(randsample(N, Nc)); mu_n(ind) = mu*slope(l)*ones(Nc,1); % generate post-slope vector
        signal_forDD = [mu_n*(1:T)] + randn(N,T)*sigma0;
        %halfway
        signal_forDD = [randn(N,H)*sigma0 signal_forDD];
        signal = signal_forDD;
        C = zeros(N,1); L = zeros(N,1); V = zeros(N,w); M = zeros(w,1); ans1 = zeros(T,1); 
        alpha = ones(N,1); beta = 100*ones(N,1); p0 = betarnd(alpha,beta);
        
        for t = 1 : T
            Indi = zeros(N,1);
            for k = min(w,t) : -1 : 2  
                for n = 1 : N
                    %C(n,1) = temp(n,t-k) / square(t-k);
                    V(n,k) = V(n,k-1) + k*signal(n,t);
                    L(n,1) = V(n,k)^2/square(k)/2;
                    if (sqrt(L(n,1)) > 2 )
                        Indi(n) = 1;
                    end
                    %L(n,1) = randn(1,1)^2/2;
                    %tt(n) = tt(n) + signal(n,k+1);
                    %L(n,1) = tt(n)^2/(t-k)/2;
                    %j = 1 : 1 : t-k;
                    %C(n,1) = (sum((signal(n,k+1:t)).*j)) / square(t-k);
                    %L(n,1) = sum((signal(n,k+1:t)).*j*C(n)) - C(n)^2*square(t-k)/2;
                end
                M(k,1) = sum(log(1-p0+p0.*exp(L)));
            end
            V(:,1) = signal(:,t);
            M(1,1) = sum(log(1-p0+p0.*exp(V(:,1).^2./2)));
            ans1(t) = max(M);
            if ( (ans1(t) > b ) && (t>H) )
                break;
            end
            %update parameter
            alpha = alpha + Indi; beta = beta + 1 - Indi;
            
            %random sample p by posterior distribution
            p0 = betarnd(alpha,beta);
        end
        tmp(runs,1) = t-H;
    end
    DD(l) = sum(tmp)/mc;
end


plot(slope,DD,'r-');