% theoretical average run length July, 20th, 2010

function aver_run_len = theo_ARL_test(b, N, p, T1)
% theoretical average run length for mixture procedure
% b: threshold
% N: number of sensors
% p: assumed fraction of affected sensors, used in the procedure
% T1: window length
% Written by Yao Xie, yaoxie@stanford.edu 7/20/2010

%%
f = @(x)abs(phi_dot_one(x, p) - b/N);
x_init = 0;
theta0 = fminsearch(f, x_init,optimset('TolX',1e-10));

mu = mu_theta(theta0,p);

% tmp = exp(-N*(theta0*phi_dot_one(theta0,p) - MGF_g(theta0,p)))
% tmp2 = sqrt(2*pi*phi_dot_dot(theta0,p))

f_val = sqrt(N)*mu/(2*theta0*sqrt(2*pi*phi_dot_dot(theta0,p)))*...
exp(-N*(theta0*phi_dot_one(theta0,p) - MGF_g(theta0,p)));

%upper = (T1+3*T1^(2/3)+(13/4)*T1^(1/3))^(1/3)/(2*N*mu); upper = (3*T1)^(1/3)/(2*N*mu); 
%upper = (T1)^(1/2)/(2*N*mu)/sqrt(sqrt(3/2)); 
upper = T1/(2*N*mu); lower = 1/(2*N*mu); 

%upper = T1.^1.5/(2*N*mu)/sqrt(3); lower = 1/(2*N*mu);

Q = quadgk(@nu_kernel2, lower, upper);
aver_run_len = 1./(Q*f_val);